/*******************************

	

		

 *******************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<sys\dos.h>
#include	<sys\iocs.h>

#include	"wakka.h"
#include	"screen.h"
#include	"pad.h"


#define	SPRITE_FILE	"WAKKA"			/* XvCgf[^ */


#define	BLOCK_X		16			/* ubN̑傫 */
#define	BLOCK_Y		16
#define	FIELD_X		(72 + 16)		/* Ղ̈ʒu */
#define	FIELD_Y		(72 + 16)


/*** XvCgR[h *****/
#define	SPR_BLOCK_S	0x010			/* ubN */
#define	BG_BACK		0x100			/* wip^[ */


#define	SPRITE_REG	(unsigned short*)0xeb0000	/* XvCgWX^AhX */


static unsigned short*	sprite_reg;			/* XvCg */

static unsigned short	block_code[] = {		/* ubÑR[h */
				0x211, 0x212,
				0x413, 0x414, 0x415, 0x416,
				0x317, 0x318, 0x319, 0x31a,
				0x41b, 0x41c,
				0x213, 0x214, 0x215, 0x216,
				0x31b, 0x31c
			};


/**********************
    Aԑ҂
 **********************/
void	v_synch(void)
{
	pad_synch();						/* pbh */
	rand();							/*  */

	while ( !(_iocs_b_bpeek((void *)0xe88001) & 0x10) );	/* A */
	while ( _iocs_b_bpeek((void *)0xe88001) & 0x10 );	/* \ */
}

/***************************************
    XvCg`
		code = p^[R[h
		x, y = \ʒu
 ***************************************/
static
void	put_sprite(unsigned short code, int x, int y)
{
	*sprite_reg++ = (unsigned short)x;		/* W */
	*sprite_reg++ = (unsigned short)y;		/* W */
	*sprite_reg++ = code;				/* p^[R[h */
	*sprite_reg++ = 3;				/* vCIeB */
}

/**************************************
    ubN`
		block = ubNԍ
		 x, y = `W
 **************************************/
static
void	draw_block(BLOCK block, int x, int y)
{
	put_sprite(block_code[block], x, y);		/* ubN㕔` */
	put_sprite((block_code[block] & 0xf00) + SPR_BLOCK_S, x, y + 16);
							/* ubNʕ` */
}

/********************
    tB[h`
 ********************/
static
void	draw_field(void)
{
	int	i, j, x, y;
	BLOCK	b;

	for (i = LEN - 1, y = FIELD_Y + BLOCK_Y*(LEN - 1); i >= 0; i--, y -= BLOCK_Y) {
		for (j = 0, x = FIELD_X; j < LEN; j++, x += BLOCK_X) {
			if ( (b = field[i][j]) >= 0 ) {		/* ubN` */
				draw_block(b, x + field_dx[i][j]*BLOCK_X/0x100,
						y + field_dy[i][j]*BLOCK_Y/0x100);
			}
		}
	}
}

/**************
    ʕ`
 **************/
void	draw_screen(void)
{
	int	ssp;

	ssp = _iocs_b_super(0);			/* X[p[oCU[h */
	sprite_reg = SPRITE_REG;		/* XvCgWX^擪 */
	v_synch();				/*  */

	draw_field();				/* tB[h` */

	while ( (unsigned long)sprite_reg < (unsigned long)(SPRITE_REG + 4*0x100) ) {
		sprite_reg += 3;
		*sprite_reg++ = 0;		/* XvCg\ */
	}
	_iocs_b_super(ssp);			/* [U[[h */
}

/**************************************
    NA\A͑҂
		f =  TRUE : NA
		    FALSE : \
	߂l	 TRUE : Q[s
		FALSE : Q[I
 **************************************/
Bool	wait_clear(Bool f)
{
	struct _symbolptr	mes = {10, 80, "bkd`q", 2, 3, 0, 2, 0};
	int	i;

	i = f ? 0 : 4;
	while ( !(get_push() & (PAD_A | PAD_B)) ) {
		draw_screen();				/* ʕ` */
		_iocs_bgscrlst(0, i % 64, i*2 % 64);	/* wiXN[ */
		if ( i < 4 ) {
			mes.color = 0x8018 + i*0x1002;
			_iocs_symbol(&mes);		/* "CLEAR"` */
			mes.x1--;
		}
		i++;

		if ( esc_key ) {		/* Q[I */
			return	FALSE;
		}
	}
	_iocs_wipe();				/* OtBbN */
	return	TRUE;
}

/************************************
    wi`
		pat = p^[ԍ
 ************************************/
void	draw_back(int pat)
{
	int	i, j;

	_iocs_bgctrlst(0, 0, 1);		/* afy[WO\ */
	_iocs_bgscrlst(0, 0, 0);		/* af\ʒu */
	pat = BG_BACK + pat*16;			/* wip^[R[h */
	for (i = 0; i < 64; i++) {
		for (j = 0; j < 64; j++) {
			_iocs_bgtextst(0, j, i, pat + (j % 4)*2 + (i % 2)
								+ ((i/2 + j/4) % 2)*8);
		}
	}
}


/****************************************
    XvCgf[^ǂݍ
		fname = t@Cl[
	߂l	0 : ǂݍ݊
		1 : ǂݍݎs
 ****************************************/
static
int	load_sprite(char* fname)
{
	FILE*	fp;
	char	*buf, *p;
	unsigned short*	c;
	int	i, j, size;

	_iocs_sp_init();					/* XvCgʏ */
	_iocs_sp_on();						/* XvCgʕ\ */

	if ( (buf = malloc(0x8000)) == NULL ) {
		eprintf("܂\n");
		return	1;
	}

	sprintf(buf, "%s.SP", fname);				/* p^[f[^ */
	if ( (fp = fopen(buf, "rb")) == NULL ) {
		eprintf("p^[t@C \"%s\" J܂\n", buf);
		return	1;
	}
	size = fread(buf, 0x80, 0x100, fp);
	fclose(fp);

	for (i = 0, p = buf; i < size; i++, p += 0x80) {
		_iocs_sp_defcg(i, 1, p);			/* XvCg` */
	}

	sprintf(buf, "%s.PAL", fname);				/* pbgf[^ */
	if ( (fp = fopen(buf, "rb")) == NULL ) {
		eprintf("pbgt@C \"%s\" J܂\n", buf);
		return	1;
	}
	size = fread(buf, sizeof(short)*0x10, 0x0f, fp);
	fclose(fp);

	c = (unsigned short*)buf;
	for (j = 0; j < size; j++) {
		for (i = 0; i < 0x10; i++) {
			_iocs_spalet(i + (1 << 0x1f), j + 1, (int)*c++);
								/* pbg` */
		}
	}

	free(buf);
	return	0;
}

/********************************
    ʏ
	߂l	0 : 
		1 : s
 ********************************/
int	init_screen(void)
{
	if ( load_sprite(SPRITE_FILE) ) {		/* XvCgǂݍ */
		return	1;
	}
	return	0;
}

/****************** End of File *************************************************/